import java.util.concurrent.RecursiveTask;

public class Busqueda extends RecursiveTask<Integer> {

	private int numero; // El entero que queremos buscar
	private int[] datos; // El array en donde queremos buscar
	private int inicio, fin; // Posiciones de inicio y fin del subarray en donde buscamos

	public Busqueda(int numero, int[] datos, int inicio, int fin) {
		this.numero = numero;
		this.datos = datos;
		this.inicio = inicio;
		this.fin = fin;
	}
	
	protected Integer compute() {
		
		int size = fin - inicio + 1;
		
		if (size<=3) {
			for (int i=inicio; i<=fin; i++) {
				if (datos[i]==numero) return(i);
			}
			return(-1);
		}
		
		else {
			int medio = (inicio+fin)/2;
			
			Busqueda mitad1 = new Busqueda(numero, datos, inicio, medio);
			mitad1.fork();

			Busqueda mitad2 = new Busqueda(numero, datos, medio+1, fin);
			mitad2.fork();

			// Devolvemos el resultado
			int resultado1 = mitad1.join();
			int resultado2 = mitad2.join();
			if (resultado1 != -1) return(resultado1);
			if (resultado2 != -1) return(resultado2);
			return(-1);
		}
	}
} // Fin clase Busqueda
